"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _HttpClient_instances, _HttpClient_got, _HttpClient_logger, _HttpClient_prefixUrl, _HttpClient_headerFunc, _HttpClient_request, _HttpClient_requestJson, _HttpClient_logAndCreateError, _HttpClient_processOptions, _CachedClient_instances, _CachedClient_httpClient, _CachedClient_logger, _CachedClient_cache, _CachedClient_get;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CachedClient = exports.TestHttpClient = exports.HttpClient = exports.ProblemDetailsError = exports.RequestException = void 0;
const got_1 = __importStar(require("got"));
const loggers_1 = require("./loggers");
class RequestException extends Error {
    constructor({ message, statusCode, innerError, stack, }) {
        super(message);
        this.statusCode = statusCode;
        this.stack = stack;
        this.innerError = innerError;
    }
}
exports.RequestException = RequestException;
class ProblemDetailsError extends RequestException {
    constructor(args) {
        const { detail, instance, statusCode, title, type, innerError, extensions } = args;
        super({ stack: innerError.stack, message: innerError.message, innerError, statusCode });
        this.detail = detail;
        this.type = type;
        this.instance = instance;
        this.title = title;
        this.extensions = extensions;
    }
}
exports.ProblemDetailsError = ProblemDetailsError;
class HttpClient {
    constructor(initParams) {
        var _a, _b, _c, _d, _e;
        _HttpClient_instances.add(this);
        _HttpClient_got.set(this, void 0);
        _HttpClient_logger.set(this, new loggers_1.NoOpLogger());
        _HttpClient_prefixUrl.set(this, void 0);
        _HttpClient_headerFunc.set(this, void 0);
        // set the method and decide to place the 'json' or 'form' property, or not when no data.
        _HttpClient_processOptions.set(this, (method, data, options) => {
            var _a;
            let jsonOrForm;
            if (options === null || options === void 0 ? void 0 : options.isForm) {
                jsonOrForm = 'form';
            }
            else if (data !== undefined && data !== null) {
                jsonOrForm = 'json';
            }
            const optionsWithComputedHeaders = {
                ...options,
                headers: {
                    ...options === null || options === void 0 ? void 0 : options.headers,
                    ...(_a = __classPrivateFieldGet(this, _HttpClient_headerFunc, "f")) === null || _a === void 0 ? void 0 : _a.call(this),
                },
            };
            const { isForm, ...gotOptions } = optionsWithComputedHeaders;
            return {
                ...(gotOptions !== null && gotOptions !== void 0 ? gotOptions : {}),
                ...(jsonOrForm !== undefined ? { [jsonOrForm]: data } : {}),
                method,
            };
        });
        const gotOptions = {
            retry: {},
            ...initParams === null || initParams === void 0 ? void 0 : initParams.options,
            context: { ...(_a = initParams === null || initParams === void 0 ? void 0 : initParams.options) === null || _a === void 0 ? void 0 : _a.context, ...initParams === null || initParams === void 0 ? void 0 : initParams.config },
        };
        if ((initParams === null || initParams === void 0 ? void 0 : initParams.prefixUrl) !== undefined) {
            gotOptions.prefixUrl = initParams.prefixUrl;
            __classPrivateFieldSet(this, _HttpClient_prefixUrl, initParams === null || initParams === void 0 ? void 0 : initParams.prefixUrl, "f");
        }
        const addToHeader = (header) => {
            var _a;
            (_a = gotOptions.headers) !== null && _a !== void 0 ? _a : (gotOptions.headers = header);
            gotOptions.headers = { ...gotOptions.headers, ...header };
        };
        if (((_b = initParams === null || initParams === void 0 ? void 0 : initParams.config) === null || _b === void 0 ? void 0 : _b.basicAuthUserName) && ((_c = initParams === null || initParams === void 0 ? void 0 : initParams.config) === null || _c === void 0 ? void 0 : _c.basicAuthPassword)) {
            addToHeader({
                Authorization: `Basic ${Buffer.from(`${initParams.config.basicAuthUserName}:${initParams.config.basicAuthPassword}`).toString('base64')}`,
            });
        }
        else if ((_d = initParams === null || initParams === void 0 ? void 0 : initParams.config) === null || _d === void 0 ? void 0 : _d.bearerToken) {
            addToHeader({ Authorization: `Bearer ${initParams.config.bearerToken}` });
        }
        if (initParams === null || initParams === void 0 ? void 0 : initParams.logger) {
            __classPrivateFieldSet(this, _HttpClient_logger, ((_e = initParams.logger.constructor) === null || _e === void 0 ? void 0 : _e.name) === 'Pino'
                ? new loggers_1.PinoLogger(initParams.logger)
                : new loggers_1.GenericLogger(initParams.logger), "f");
        }
        if (initParams === null || initParams === void 0 ? void 0 : initParams.headerFunc) {
            __classPrivateFieldSet(this, _HttpClient_headerFunc, initParams.headerFunc, "f");
        }
        __classPrivateFieldSet(this, _HttpClient_got, got_1.default.extend(gotOptions), "f");
    }
    async get(path, options) {
        const opts = __classPrivateFieldGet(this, _HttpClient_processOptions, "f").call(this, 'GET', undefined, options);
        return await __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_requestJson).call(this, {
            path,
            options: opts,
        });
    }
    async post(path, data, options) {
        const opts = __classPrivateFieldGet(this, _HttpClient_processOptions, "f").call(this, 'POST', data, options);
        return await __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_requestJson).call(this, {
            path,
            options: opts,
        });
    }
    async put(path, data, options) {
        const opts = __classPrivateFieldGet(this, _HttpClient_processOptions, "f").call(this, 'PUT', data, options);
        return await __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_requestJson).call(this, {
            path,
            options: opts,
        });
    }
    async patch(path, data, options) {
        const opts = __classPrivateFieldGet(this, _HttpClient_processOptions, "f").call(this, 'PATCH', data, options);
        return await __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_requestJson).call(this, {
            path,
            options: opts,
        });
    }
    async delete(path, options, data) {
        const o = __classPrivateFieldGet(this, _HttpClient_processOptions, "f").call(this, 'DELETE', data, options);
        await __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_requestJson).call(this, {
            path,
            options: o,
        });
        return undefined;
    }
    /**
     * @description Access to all 'got' supported options, returns the response instead of JSON.
     * @param {string} path path or url
     * @param {OptionsInit} options all options supported by 'got'
     * @return {Promise<Response<T = unknown>>}
     */
    async raw(path, options) {
        return (await __classPrivateFieldGet(this, _HttpClient_got, "f").call(this, path, options));
    }
}
exports.HttpClient = HttpClient;
_HttpClient_got = new WeakMap(), _HttpClient_logger = new WeakMap(), _HttpClient_prefixUrl = new WeakMap(), _HttpClient_headerFunc = new WeakMap(), _HttpClient_processOptions = new WeakMap(), _HttpClient_instances = new WeakSet(), _HttpClient_request = function _HttpClient_request(path, options) {
    const { abortSignal, ...gotOptions } = options !== null && options !== void 0 ? options : {};
    const responsePromise = __classPrivateFieldGet(this, _HttpClient_got, "f").call(this, path, { ...gotOptions });
    if (abortSignal) {
        abortSignal.addEventListener('abort', () => {
            responsePromise.cancel();
        });
    }
    return responsePromise;
}, _HttpClient_requestJson = async function _HttpClient_requestJson({ path, options }) {
    const sanitizedPath = path.startsWith('/') ? path.slice(1) : path;
    try {
        const responsePromise = __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_request).call(this, sanitizedPath, options);
        const [response, json] = await Promise.all([responsePromise, responsePromise.json()]);
        __classPrivateFieldGet(this, _HttpClient_logger, "f").logSuccess(response, options);
        return json;
    }
    catch (error) {
        throw __classPrivateFieldGet(this, _HttpClient_instances, "m", _HttpClient_logAndCreateError).call(this, { error, path: sanitizedPath });
    }
}, _HttpClient_logAndCreateError = function _HttpClient_logAndCreateError({ error, path }) {
    var _a, _b, _c, _d, _e;
    let code;
    if (error instanceof got_1.HTTPError || error instanceof got_1.CancelError) {
        code = (_b = (_a = error.response) === null || _a === void 0 ? void 0 : _a.statusCode) !== null && _b !== void 0 ? _b : error.code;
        __classPrivateFieldGet(this, _HttpClient_logger, "f").logFailure(error);
        if (((_d = (_c = error.response) === null || _c === void 0 ? void 0 : _c.headers['content-type']) === null || _d === void 0 ? void 0 : _d.includes('application/problem+json')) &&
            typeof ((_e = error.response) === null || _e === void 0 ? void 0 : _e.body) === 'string') {
            try {
                const responseBody = JSON.parse(error.response.body);
                const { detail, instance, title, type, ...extensions } = responseBody;
                if (type && title) {
                    return new ProblemDetailsError({
                        detail,
                        instance,
                        title,
                        type,
                        extensions: extensions !== null && extensions !== void 0 ? extensions : {},
                        statusCode: code,
                        innerError: error,
                    });
                }
            }
            catch (_parsingError) {
                /* empty */
            }
        }
    }
    if (error instanceof Error) {
        const { message, stack } = error;
        return new RequestException({
            message: `${__classPrivateFieldGet(this, _HttpClient_prefixUrl, "f")}/${path} ${message}`,
            statusCode: code,
            innerError: error,
            stack,
        });
    }
    return error;
};
class TestHttpClient {
    constructor(routePayloads) {
        this._routePayloads = routePayloads;
        this.calls = { get: {}, post: {}, patch: {}, put: {}, delete: {} };
    }
    async get(route) {
        var _a;
        // storing `undefined` here makes it non-obvious to verify (you have to use the `in` keyword)
        // we don't want to potentially break people's test by changing it though
        this.calls.get[route] = undefined;
        const response = (_a = this._routePayloads.get) === null || _a === void 0 ? void 0 : _a[route];
        return Promise.resolve(response);
    }
    async post(route, data) {
        var _a;
        this.calls.post[route] = data || {};
        const response = (_a = this._routePayloads.post) === null || _a === void 0 ? void 0 : _a[route];
        return response;
    }
    async put(route, data) {
        var _a;
        this.calls.put[route] = data || {};
        const response = (_a = this._routePayloads.put) === null || _a === void 0 ? void 0 : _a[route];
        return response;
    }
    async patch(route, data) {
        var _a;
        this.calls.patch[route] = data || {};
        const response = (_a = this._routePayloads.patch) === null || _a === void 0 ? void 0 : _a[route];
        return response;
    }
    async delete(route) {
        var _a;
        // storing `undefined` here makes it non-obvious to verify (you have to use the `in` keyword)
        // we don't want to potentially break people's test by changing it though
        this.calls.delete[route] = undefined;
        const response = (_a = this._routePayloads.delete) === null || _a === void 0 ? void 0 : _a[route];
        return response;
    }
    // eslint-disable-next-line class-methods-use-this
    raw(_path, _options) {
        return Promise.reject(new Error('method not implemented'));
    }
    resetCalls() {
        this.calls = { get: {}, post: {}, patch: {}, put: {}, delete: {} };
    }
}
exports.TestHttpClient = TestHttpClient;
class CachedClient {
    constructor(httpClient, logger, cache) {
        _CachedClient_instances.add(this);
        _CachedClient_httpClient.set(this, void 0);
        _CachedClient_logger.set(this, void 0);
        _CachedClient_cache.set(this, void 0);
        __classPrivateFieldSet(this, _CachedClient_httpClient, httpClient, "f");
        __classPrivateFieldSet(this, _CachedClient_logger, logger, "f");
        __classPrivateFieldSet(this, _CachedClient_cache, cache, "f");
    }
    async get(route) {
        return await __classPrivateFieldGet(this, _CachedClient_instances, "m", _CachedClient_get).call(this, route, false);
    }
    async getNoCache(route) {
        return await __classPrivateFieldGet(this, _CachedClient_instances, "m", _CachedClient_get).call(this, route, true);
    }
    async post(route, data) {
        return await __classPrivateFieldGet(this, _CachedClient_httpClient, "f").post(route, data);
    }
    async put(route, data) {
        return await __classPrivateFieldGet(this, _CachedClient_httpClient, "f").put(route, data);
    }
    async patch(route, data) {
        return await __classPrivateFieldGet(this, _CachedClient_httpClient, "f").patch(route, data);
    }
    async delete(route) {
        return await __classPrivateFieldGet(this, _CachedClient_httpClient, "f").delete(route);
    }
    async raw(path, options) {
        return await __classPrivateFieldGet(this, _CachedClient_httpClient, "f").raw(path, options);
    }
}
exports.CachedClient = CachedClient;
_CachedClient_httpClient = new WeakMap(), _CachedClient_logger = new WeakMap(), _CachedClient_cache = new WeakMap(), _CachedClient_instances = new WeakSet(), _CachedClient_get = async function _CachedClient_get(route, noCache) {
    var _a;
    if (!noCache) {
        const cached = __classPrivateFieldGet(this, _CachedClient_cache, "f").get(route);
        if (cached) {
            (_a = __classPrivateFieldGet(this, _CachedClient_logger, "f")) === null || _a === void 0 ? void 0 : _a.debug(`returning cached result for route "${route}"`);
            return cached;
        }
    }
    const result = await __classPrivateFieldGet(this, _CachedClient_httpClient, "f").get(route);
    __classPrivateFieldGet(this, _CachedClient_cache, "f").set(route, result);
    return result;
};
//# sourceMappingURL=http-client.js.map