import { CancelError, HTTPError, Response } from 'got/dist/source';
import { HttpLogger, Logger, RequestOptions } from './interfaces';
export declare class NoOpLogger implements HttpLogger {
    logSuccess(_response: Response, _options: RequestOptions): void;
    logFailure(_error: HTTPError | CancelError): void;
}
export declare class GenericLogger implements HttpLogger {
    #private;
    constructor(logger: Logger);
    logSuccess(response: Response, options: RequestOptions): void;
    logFailure(error: HTTPError | CancelError): void;
}
export declare class PinoLogger implements HttpLogger {
    #private;
    constructor(logger: Logger);
    logSuccess(res: Response): void;
    logFailure(error: HTTPError | CancelError): void;
}
export declare const redact: (options: RequestOptions) => RequestOptions;
export declare const redactSensitiveHeaders: (options: RequestOptions) => void;
export declare const redactSensitiveProps: (options: RequestOptions) => void;
